/*
 *	eek - run-for-yer-life type game. avoid robots, etc.
 *
 *	based loosely on chase & robots public domain games
 *
 *	Copyright 1988, 1990, Miles ONeal, Austin, TX, USA. All rights reserved.
 *	Copyright 1993, 1997-8 Roadkills-R-Us, Austin, TX, USA. All rights reserved.
 */

#define ALLOC_GLOBALS

#include <unistd.h>
#include "eek.h"

static void LegalStuff();
static void ParseArgs();
static void Usage();
static void Version();
extern char *getlogin();

static int first_level = 0;
static int need_menu = 1;


main (argc, argv)

int argc;
char *argv[];
{
	int l;

	SetupSignalHandlers();
	getcwd(orig_cwd, 1024);
	chdir(eek_dir);
	ParseArgs(argc, argv);
	if (InitGame()) {
		if (!(training) && need_menu)
			DoMainMenu();
		for (l = 1; l < first_level; l++)
			InitLevel();
		while (health) {
			InitLevel();
			Play();
		}
	}
}



static void
ParseArgs(argc, argv)
int argc;
char *argv[];
{
	/* register */ int argn;

	if (!strcmp(argv[0], TRAINING))
		training++;
	for (argn = 1; argn < argc; argn++) {
		if (strncmp(argv[argn], "-c", 2) == 0) {
			LegalStuff();
		} else if (strncmp(argv[argn], "-l", 2) == 0) {
			first_level = atoi(argv[++argn]);
			testing++;
			need_menu = 0;
		} else if (strncmp(argv[argn], "-m", 2) == 0) {
			need_menu = 0;
		} else if (strncmp(argv[argn], "-M", 2) == 0) {
			madman = 1;
			need_menu = 0;
		} else if (strncmp(argv[argn], "-n", 2) == 0) {
			user_name = argv[++argn];
		} else if (strncmp(argv[argn], "-s", 2) == 0) {
			speed = atoi(argv[++argn]);
			if (speed <= 0)
				speed = wait_time = 0;
			else if (speed == 1)
				wait_time = 3;
			else if (speed == 2)
				wait_time = 2;
			else /* speed >= 3 */
				wait_time = 1;
		} else if (strncmp(argv[argn], "-t", 2) == 0) {
			training++;
		} else if (strncmp(argv[argn], "-T", 2) == 0) {
			testing++;
			need_menu = 0;
		} else if (strncmp(argv[argn], "-v", 2) == 0) {
			Version();
		} else {
			Usage(argv[0]);
		}
	}
	if (! *user_name)
		user_name = getlogin();
}



static void
Usage(name)
char *name;
{
	fprintf(stderr, "Usage: %s [-c] [-h|?] [-l level] [-m] [-M] [-n name] [-t] [-T] [-v]\n\
	-c       : show copyright & warranty information\n\
	-h or -? : help on command line
	-l level : level to start at (sets Testing flag)\n\
	-m       : no menu (start game)\n\
	-M       : Madman (self-test mode)\n\
	-n name  : name of player (for scorefile)\n\
	-t       : training mode (can't be killed)\n\
	-T       : testing mode (no score saved, extra info displayed)\n\
	-v       : version\n", name);
	fflush(stderr);
	exit(1);
}



static void
Version()
{
	fprintf(stderr, "eek version %s, Copyright 1988, 1990, 1993, 1997-8 Roadkills-R-Us, Austin, TX\n\
    Contact Miles O'Neal <meo@rru.com> with questions, etc.\n", EEK_VERSION);
	fflush(stderr);
	exit(1);
}



static void
LegalStuff()
{
	printf(legalstuff);
	exit(1);
}
